﻿using System;
using ff14bot.Behavior;
using ff14bot.Interfaces;
using TreeSharp;
using Clio.Utilities;
using System.Threading.Tasks;
using ff14bot.Managers;
using ff14bot.Behavior;
using System.Collections.Generic;
using System.Linq;
using Buddy.Coroutines;
using ff14bot;
using ff14bot.AClasses;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.NeoProfiles;
using System.Diagnostics;
using TreeSharp;

namespace Wimpy
{
	public class WimpyPlugin : ff14bot.AClasses.BotPlugin
	{
		private Composite _WimpyCoroutine;
	    private static Vector3 saveloc=new Vector3();
        Stopwatch stopwatch = new Stopwatch();
        private static float Limit = 30f;  //precentage of health when we should start run away
		public bool Enabled { get; private set; }

		#region Plugin Implementation
        public override string Author
		{
			get { return " Dark Wolf"; }
		}

		public override string ButtonText
		{
			get { return "Settings"; }
		}

		public string Description
		{
			get { return "Run away"; }
		}

		public override string Name
		{
			get { return " Wimpy"; }
		}

		public override void OnButtonPress()
		{
			{
			}
		}

       
		public override void OnDisabled()
		{
			TreeHooks.Instance.OnHooksCleared -= OnHooksCleared;

			if (Enabled) { UnhookWimpy(); }
			Enabled = false;
		}

		public override void OnEnabled()
		{
			TreeHooks.Instance.OnHooksCleared += OnHooksCleared;

			if (!Enabled) { HookWimpy(); }
			Enabled = true;
		}

		public override void OnInitialize()
		{
              stopwatch.Start();

              _WimpyCoroutine = new Decorator(r => Core.Me.CurrentHealthPercent <= Limit,
                new ActionRunCoroutine(r => BeWimpy()));
		}

		public override void OnPulse()
		{
            if (stopwatch.ElapsedMilliseconds > 5000)
            {
                if (!Core.Me.InCombat)
                saveloc = Core.Me.Location;

                stopwatch.Restart();
            }
            
        }

		public override void OnShutdown()
		{
			if (Enabled) { UnhookWimpy(); }
			Enabled = false;
		}

		public override Version Version
		{
			get { return new Version(0, 0, 2); }
		}

		public override bool WantButton
		{
			get { return false; }
		}

		public bool Equals(ff14bot.AClasses.BotPlugin other)
		{
			return other.Name == Name && other.Author == Author;
		}

		#endregion

        private void OnHooksCleared(object sender, EventArgs args)
		{
			HookWimpy();
		}

		public void HookWimpy()
		{
			TreeHooks.Instance.AddHook("PreCombatLogic", _WimpyCoroutine);
            Logging.Write("Wimpy hooked.");
		}

		public void UnhookWimpy()
		{
			TreeHooks.Instance.RemoveHook("PreCombatLogic", _WimpyCoroutine);
            Logging.Write("Wimpy unhooked.");
	  }

        public static async Task<bool> BeWimpy()
        {
            var savePoi = Poi.Current;
            Logging.Write("Health is under {0}% we run away ",Limit);
            Navigator.Stop();
            bool savelocdone = false;
            var aetherytes = WorldManager.AetheryteIdsForZone(WorldManager.ZoneId);
            if (aetherytes != null && aetherytes.Any())
            {
                var location = aetherytes.Select(x => x.Item2).OrderBy(x => Core.Me.Distance(x)).FirstOrDefault();
                while (GameObjectManager.Attackers.Any() )
                {

                    if (Actionmanager.IsSprintReady && MovementManager.IsMoving && !Core.Player.IsMounted)
                    {
                        Actionmanager.Sprint();
                    }

                    if (savelocdone==true)
                    {
                        Logging.Write("Still having aggro from {1}. So now we run towards the next Aetheryte{0}.", location, GameObjectManager.Attackers);
                    Navigator.MoveTo(location);
                     await Coroutine.Yield(); 
                    }
                    else
                    {
                        Logging.Write("Moving to last location where we did not yet were in combat");
                    Navigator.MoveTo(saveloc);
                    if (saveloc.Distance(Core.Me.Location) < 3)
                        savelocdone = true;
                   
                   
                    await Coroutine.Yield();
                    }

                    
                }

            }
            try { 
            Poi.Current = savePoi;
                }
            catch (Exception e)
            {
               
            }
            return true;
        }

	
       
    
    private static async Task<bool> CarefulSleep(uint ms)
    {
        var stopwatch = new Stopwatch();
        stopwatch.Start();

        while (stopwatch.ElapsedMilliseconds < ms )
        {
            await Coroutine.Yield();
        }
        stopwatch.Stop();

        return true;
    }

  
 }
}
